//2009-12-22
/*----------------------------------------------------------------------------

ETv
	MEGA88jo[T{[h{fWbgWN7ZOLCDڑvO
	uPD7225G fWbg\200-

Eݒ
	ATMEGA88-20PU
	Low: 01100010
	     ||||++++-- CKSEL[3:0] VXeNbNI
	     ||++-- SUT[1:0] N
	     |+-- CKOUT (0:PB0ɃVXeNbNo)
	     +-- CKDIV8 NbNl (1:1/1, 0:1/8)
	
	High:11-11111
	     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
	     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
	     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
	     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
	     |+-- DWEN (On-ChipfobO 1:, 0:L)
	     +-- RSTDISBL (RESETs 1:L, 0:(PC6))
	
	Ext: -----001
	          ||+-- BOOTRST f[^V[gQ
	          ++-- BOOTSZ[1:0] f[^V[gQ
	
	Cal: 182

	CPUCLock = 8.0MHz * 1/8 = 1000kHz(U)

E|[g
	PB0(14pin)FSCK#     (out)
	PB1(15pin)FSI       (out)
	PB2(16pin)FBUSY#    (in)
	PB3(17pin)FCMD/DATA#(out)
	PB4(18pin)FCS#      (out)
	PB5(19pin)FRESET#   (out)
	PB6( 9pin)F              
	PB7(10pin)F              

	PC0(23pin)F
	PC1(24pin)F
	PC2(25pin)F
	PC3(26pin)F
	PC4(27pin)F
	PC5(28pin)F

	PD0( 2pin)FUART_RX(in)
	PD1( 3pin)FUART_TX(out)
	PD2( 4pin)F
	PD3( 5pin)F
	PD4( 6pin)F
	PD5(11pin)F
	PD6(12pin)F
	PD7(13pin)F

E쓙
	volty98
	WinAVRRpCpC\[XR[h
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
CN[h
----------------------------------------------------------------------------*/
#include <avr/io.h>//K{
#include <avr/interrupt.h>//荞݊֘A
#include <avr/pgmspace.h> //vO̒萔ANZX
#include "Wait.h"
//#include "USART.h"
//#include "eep_rw.h"

/*----------------------------------------------------------------------------
|[gE萔`
----------------------------------------------------------------------------*/
// DDR 1=Out 0=In
//PORT 1=High / Pull-up
//     0=Low  / High-Z
#define DEF_DDRB  0xFB //|[gB oooo oioo
#define DEF_PORTB 0x0F //|[gB LLLL HUHH
#define DEF_DDRC  0xFF //|[gC oooo oooo
#define DEF_PORTC 0x00 //|[gC LLLL LLLL
#define DEF_DDRD  0xFE //|[gD oooo oooi
#define DEF_PORTD 0x01 //|[gD LLLL LLLU

/*----------------------------------------------------------------------------
}N`
----------------------------------------------------------------------------*/
#define NOP() __asm__ __volatile__ ("nop")
#define WDR() __asm__ __volatile__ ("WDR")
#define SLEEP() __asm__ __volatile__ ("SLEEP")

/*----------------------------------------------------------------------------
vO̒萔
----------------------------------------------------------------------------*/
/*
uint8_t __attribute__((section(".eeprom"))) eeprom_data[] = {
//R0|  R1|...                                           ...| R12| R13| 0 Œ  |
0x02,0x00,0xC0,0x37,0xD8,0x5D,0x88,0x4C,0x09,0x4D,0x28,0x8C,0x04,0x00,0x00,0x00,
// ch1   |   ch2   |   ch3   |   ch4   |   ch5   |   ch6   |   ch7   |ch|    |
0x24,0x4C,0x26,0x10,0x28,0x66,0x29,0xD4,0x30,0x56,0x00,0x00,0x00,0x00,0x05,0x00
};
*/

/*----------------------------------------------------------------------------
O[oϐ
----------------------------------------------------------------------------*/
//volatile uint8_t sw_flag;
//register uint8_t sw_flag asm("r5");



/*----------------------------------------------------------------------------
vO
----------------------------------------------------------------------------*/
//----------------------------------------------------------------------------
//yT@vz^C}/JE^0̐ݒ uU[TEhp
//y@z
//y߂lz
/*
void Timer0_Init(void)
{
	TCCR0A = ((1<<COM0B0) | (2<<WGM00));//OC0B[qhOo, rvx10
	TCCR0B = ((0<<WGM02) | (3<<CS00));//rvNA0xx, l011 CK/64
	TIMSK0 &= ~(1<<OCIE0A);//rvAs
	TIMSK0 &= ~(1<<OCIE0B);//rvBs
	TCNT0 = 0x00;
	OCR0A = 0;
	OCR0B = 0;
}
*/
/*
//----------------------------------------------------------------------------
//yT@vz{^pAsω荞݊֘Ȁ
//y@z
//y߂lz
void SWINT_Init(uint8_t on)
{
	if(on)
	{
		PCICR = (1<<PCIE1);//PCINT8~14
		PCMSK1 = ((1<<PCINT9) | (1<<PCINT8));//PCINT8,9(PC0,PC1)荞݂
	}
	else
	{
//		PCICR = (1<<PCIE1);//PCINT8~14
		PCMSK1 &= ~((1<<PCINT9) | (1<<PCINT8));//PCINT8,9(PC0,PC1)荞݂s
	}
	PCIFR = (1<<PCIF1);//tONA
}
*/
/*----------------------------------------------------------------------------
荞
----------------------------------------------------------------------------*/
//----------------------------------------------------------------------------
//yT@vzsω荞PCINT1(PCINT8~14) 
//y@z
//y߂lz
/*
ISR(PCINT1_vect)
{

	cli();

	//`^O
	Wait(50);
	
	//FSWH
	if(bit_is_clear(PIN_SW,BIT_SW1))
	{
		Play(20,"cde");
		flag_sw = PUSH_SW1;
	}
	//FSWH
	if(bit_is_clear(PIN_SW,BIT_SW2))
	{
		Play(20,"EGB");
		flag_sw = PUSH_SW2;
	}
	sei();

}
*/
/*----------------------------------------------------------------------------
Local functions
----------------------------------------------------------------------------*/
/*
void USART_puts_hex(uint8_t *buf,uint8_t len)
{
	uint8_t lp = 0;
	for(lp = 0;lp < len;lp++)
	{
		USART_puth(*(buf+lp));
		USART_putc(' ');
	}
	return;
}
*/

/*----------------------------------------------------------------------------
C֐
----------------------------------------------------------------------------*/
int main(void)
{

	//|[gݒǍ̓͊eInitłƐݒ肷AgpsHo
	DDRB = DEF_DDRB;
	DDRC = DEF_DDRC;
	DDRD = DEF_DDRD;
	PORTB = DEF_PORTB;
	PORTC = DEF_PORTC;
	PORTD = DEF_PORTD;

	//ϐ
	uint8_t tmp,lp = 0,data = 0;
	uint8_t lcd[10];

	//
//	Timer0_Init();//BZ
//	SWINT_Init(1);
//	USART_Init();

	sei();//荞ݏ

	LCD_Reset();
	
	while(1)
	{
		for(lp = 0;lp < 10;lp++)
			lcd[lp] = lp;
		LCD_print(lcd);
		Wait(1000);
		for(lp = 0;lp < 10;lp++)
			lcd[lp] = lp+6;
		LCD_print(lcd);
		Wait(1000);

		for(lp = 0;lp < 10;lp++)
		{
			LCD_dot(lp,1);
			Wait(500);
			LCD_dot(lp,0);
			Wait(100);
		}
	}

	
	
	

	//C[v
	for(;;)
	{

	}
	return 0;

}
//----------------------------------------------------------------------------
